package com.jdauny;
import java.io.*;
import java.util.*;
public class Link extends Observable implements Serializable
{
	int m_iType;
	int m_iPriority;
	int m_iSame;
	int m_iRetries;
	int m_iID;
	int m_iSize;
        float m_fProgress;
	String m_sUrl;
	String m_sDir;
	String m_sFileName;
	String m_sState;
	String m_sError;

	public Link(String url)
	{
		m_sUrl = url;
		m_iID = 0;
		m_iSize = 0;
		m_sState = "local";
		setFileName();
	}

	public Link(String url,int id,int size,String state)
	{
		m_sUrl = url;
		m_iID = id;
		m_iSize = size;
		m_sState = state;
		setFileName();
	}

	void setFileName()
	{
		int index = m_sUrl.lastIndexOf("/");
		m_sFileName = m_sUrl.substring(index+1);
                fireChanged();
	}

	/** Setzt alle Informationen wie im bergebenen Link */
	public void setInfoas(Link link)
	{
		m_iSame = link.getSame();
		m_iRetries = link.getRetries();
		m_iPriority = link.getPriority();
		m_iType = link.getType();
		m_iID = link.getID();
		m_iSize = link.getSize();
		m_sUrl = link.getUrl();
		m_sState = link.getState();
		m_sError = link.getError();
		m_sFileName = link.getFileName();
		m_sDir = link.getDir();
                m_fProgress = link.getProgress();
                fireChanged();
	}

	/** bprft Link auf bergebene ID */
	public boolean HasID(int id)
	{
		return (id==m_iID);
	}

	/** Liefert die ID des Links */
	public int getID()
	{
		return m_iID;
	}

	/** Updated Info ber Link
	@param id ID des Link
	@param size Gre des Files
	@param state Status des Download
	@param error Art des aufgetretenen Fehlers
	*/
	public void Update(int id, int size, String state,String error)
	{
		m_iID = id;
		m_iSize = size;
		m_sState = state;
		m_sError = error;
                fireChanged();
	}

	/** Liefert die Url des Links */
	public String getUrl()
	{
		return m_sUrl;
	}

	/** Liefert das Verzeichnis in das die Url geladen werden soll */
	public String getDir()
	{
		return m_sDir;
	}

	/** Liefert den aufgetretenen Error */
	public String getError()
	{
		return m_sError;
	}

	/** Liefert den Namen des downzuladenden Files */
	public String getFileName()
	{
		return m_sFileName;
	}

	public String getState()
	{
		return m_sState;
	}

	public int getRetries()
	{
		return m_iRetries;
	}

	public int getPriority()
	{
		return m_iPriority;
	}

	public int getSame()
	{
		return m_iSame;
	}

	public int getType()
	{
		return m_iType;
	}

	/** Liefert Gre des Files */
	public int getSize()
	{
		return m_iSize;
	}


	public void setType(int type)
	{
		m_iType = type;
                fireChanged();
	}

        public void setProgress(float progress)
        {
                m_fProgress = progress;
                fireChanged();
        }

        public float getProgress()
        {
                return m_fProgress;
        }

        void fireChanged()
        {
                //System.out.println("FIRE_CHANGE");
                setChanged();
                notifyObservers(this);
        }

	public void setLinkInfo(String dir,int retries,int same,int priority)
	{
		m_sDir = dir;
		m_iRetries = retries;
		m_iSame = same;
		m_iPriority = priority;
                fireChanged();
	}

	public String[] showLink()
	{
		String[] result = {new Integer(m_iID).toString(),m_sFileName,new Integer(m_iSize).toString(),m_sState};
		return result;
	}

	public String toString()
	{
		return ("ID:"+m_iID+" | Url:"+m_sUrl+" | Dir:"+m_sDir+" | State:"+m_sState+" | Size:"+m_iSize);
	}

        public boolean equals(Link toCompare)
        {
              return toCompare.HasID(m_iID);
        }
}