package com.jdauny.client;

// Dauny Dialog
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;
import java.awt.datatransfer.*;
import com.jdauny.Link;
import java.applet.*;
import logger.Logger;

public class DaunyGUI extends JFrame implements DaunyOutput//, ClipboardOwner
{
//  final static String VERSION = "1.23";
//  final static String VERSIONTIME = "23.02.2003 - 13:53";
  final static String VERSION = "1.231";
  final static String VERSIONTIME = "13.12.2003 - 22:58";

  public static int WIDTH = 560;
  public static int HEIGHT = 430;
  public static String TITLE = "JDauny Client";

  // Clipboard
  Timer counter;
  String clipboard = "";


  // Workingarea
  String[] columnames = {"ID","Filename","Size","State"};
  JLabel inputinfo = new JLabel("InputField:");
  JTextField input = new JTextField(20);
  JPanel easyinput = new JPanel();
  JTable urltable;
  LinkTableModel tablemodel;
  LinkTableColumnModel columnmodel;
  JPanel ButtonPanel = new JPanel();

  JButton button_for_connection_;
  JButton button_for_clipboardcontrol_;
  JButton button_for_enter_url_;
  JButton button_for_reset_linklist_;
  JButton button_for_update_linklist_;

  JToolBar toolbar = new JToolBar();

  // Menu
  JMenuBar menuBar = new JMenuBar();
  JMenu fileMenu = new JMenu("File");
  JMenuItem idImport = new JMenuItem("ID Import");
  JMenuItem fileImport = new JMenuItem("Import");
  JMenuItem fileExport = new JMenuItem("Export");
  JMenuItem fileExit = new JMenuItem("Exit");
  JMenu optionsMenu = new JMenu("Options");
  JMenuItem optionsServer = new JMenuItem("Server");
  JMenuItem optionsDownload = new JMenuItem("Download");
  JMenuItem optionsPrograms = new JMenuItem("Programs");
  JMenuItem optionsPwd = new JMenuItem("Change PWD");
  JMenuItem options_auto_update_ = new JMenuItem("Auto Update");
  JMenu commandsMenu = new JMenu("Commands");
  JMenuItem commandsConnect = new JMenuItem("Connect");
  JMenuItem commandsDisconnect = new JMenuItem("Disconnect");
  JMenuItem commandsVar = new JMenuItem("VAR");
  JMenuItem commandsVer = new JMenuItem("VER");
  JMenuItem commandsUsers = new JMenuItem("USERS");
  JMenuItem commandsSysInfo = new JMenuItem("SYSINFO");
  JMenuItem commandsCMD = new JMenuItem("CMD");
  JMenuItem commandsStore = new JMenuItem("Store");

  JMenu programsMenu = new JMenu("Programs");
  JMenuItem programsFtp = new JMenuItem("ftp");
  JMenuItem programsTelnet = new JMenuItem("telnet");
  JMenu look_feelMenu = new JMenu("Look & Feel");
  JMenuItem look_feelMetal = new JMenuItem("Metal");
  JMenuItem look_feelMotif = new JMenuItem("Motif");
  JMenuItem look_feelWindows = new JMenuItem("Windows");

  JMenu aboutMenu = new JMenu("About");
  JMenuItem aboutVersion = new JMenuItem("Version");

  JMenu adminMenu = new JMenu("Admin");
  JMenuItem adminAddUser = new JMenuItem("Add User");
  JMenuItem adminDelUser = new JMenuItem("Delete User");
  JMenuItem adminGetUsers = new JMenuItem("Get Users");

  // KontextMenu
  JPopupMenu kontextMenu = new JPopupMenu();
  JMenuItem kontextUpdate = new JMenuItem("Update");
  JMenuItem kontextReget = new JMenuItem("Reget");
  JMenuItem kontextStop = new JMenuItem("Stop");
  JMenuItem kontextRemove = new JMenuItem("Delete File");

  // Kommunikation
  public DaunySocket m_dsSocket;
  // Dialoge
  Dialog_Server m_dServer;
  Dialog_Download m_dDownload;
  Dialog_Programs m_dPrograms;
  Dialog_CMD m_dCMD;
  Dialog_Store m_dStore;
  Dialog_PwdChange m_dChangePwd;
  Dialog_IDImport m_dIDImport;
  JOptionPane Message;


  // Sound
  AudioClip clip;

  Timer timer_;


  public DaunyGUI()
  {
    super(TITLE);
    init();
    start();
  }

  final void init()
  {
    Image img;
    img = getToolkit().getImage(getClass().getResource("images/DaunyIcon.gif"));
    setIconImage(img);
    setSize(WIDTH,HEIGHT);
    m_dServer = new Dialog_Server(this);
    m_dIDImport = new Dialog_IDImport(this);
    m_dDownload = new Dialog_Download(this);
    m_dPrograms = new Dialog_Programs(this);
    m_dCMD = new Dialog_CMD(this);
    m_dStore = new Dialog_Store(this);
    m_dChangePwd = new Dialog_PwdChange(this);
    m_dsSocket = new DaunySocket(this,true);
    Message = new JOptionPane();
    counter = new Timer(500,new TimerHandler());
    clip  = Applet.newAudioClip(getClass().getResource("sound/catch.wav"));
    buildGUI();
    setActionCommands();
    setupEventHandler();
    setShortCuts();
    if(System.getProperty("os.name").startsWith("Windows"))
    {
      this.changeLook_Feel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
    }
  }


  public void start()
  {
    show();
  }


  void buildGUI()
  {
    setupMenuBar();
    setupKontextMenu();
    createButton();
    fillWorkingArea();
    //	layoutComponents();
    setting_up_Tooltips();
  }

  void createButton()
  {
    button_for_connection_ = new JButton(getImageIcon("images/connection.gif"));
    button_for_clipboardcontrol_ = new JButton(getImageIcon("images/clipboard_off.gif"));
    button_for_enter_url_ = new JButton(getImageIcon("images/get.gif"));
    button_for_reset_linklist_ = new JButton(getImageIcon("images/reset.gif"));
    button_for_update_linklist_ = new JButton(getImageIcon("images/reload.gif"));
  }

  ImageIcon getImageIcon(String pth)
  {
    return (new ImageIcon(Toolkit.getDefaultToolkit().getImage(getClass().getResource(pth))));
  }

  void fillWorkingArea()
  {
    tablemodel = new LinkTableModel();
    columnmodel = new LinkTableColumnModel();
    urltable = new JTable(tablemodel,columnmodel);
    java.util.Enumeration all_links = m_dsSocket.getLinks();
    while(all_links.hasMoreElements())
    {
      tablemodel.addLink(((Link)all_links.nextElement()));
    }
    toolbar.add(button_for_connection_);
    toolbar.add(button_for_clipboardcontrol_);
    toolbar.add(button_for_enter_url_);
    toolbar.add(button_for_update_linklist_);
    toolbar.add(button_for_reset_linklist_);
    getContentPane().add("North",toolbar);

    easyinput.add(inputinfo);
    easyinput.add(input);
    getContentPane().add("Center",new JScrollPane(urltable));
  }

  void setActionCommands()
  {
    // Buttons
    button_for_enter_url_.setActionCommand("get");
    button_for_reset_linklist_.setActionCommand("reset");
    button_for_connection_.setActionCommand("connect");
    button_for_clipboardcontrol_.setActionCommand("clipboard_off");
    button_for_update_linklist_.setActionCommand("update");
    // KontextMenu
    kontextUpdate.setActionCommand("kontext_update");
    kontextReget.setActionCommand("kontext_reget");
    kontextStop.setActionCommand("kontext_stop");
    kontextRemove.setActionCommand("kontext_remove");
  }

  /** Festlegen der Tooltiptexte der einzelnen Buttons */
  void setting_up_Tooltips()
  {
    button_for_reset_linklist_.setToolTipText("clear all links");
    button_for_clipboardcontrol_.setToolTipText("check the clipboard [alt-a]");
    button_for_update_linklist_.setToolTipText("refresh table [alt-r]");
    button_for_enter_url_.setToolTipText("enter url [alt-e]");
    button_for_connection_.setToolTipText("connect to server [alt-c]");
  }

  /** Bereitet Menubar samt Eintrge vor */
  void setupMenuBar()
  {
    fileMenu.add(idImport);
    fileMenu.add(fileImport);
    fileMenu.add(fileExport);
    fileMenu.add(fileExit);
    optionsMenu.add(optionsServer);
    optionsMenu.add(optionsDownload);
    optionsMenu.add(optionsPrograms);
//    optionsMenu.add(options_auto_update_);

    commandsMenu.add(commandsConnect);
    commandsMenu.add(commandsDisconnect);
    commandsMenu.add(optionsPwd);
    commandsMenu.add(commandsCMD);
    commandsMenu.add(commandsStore);
    commandsMenu.add(commandsVar);
    commandsMenu.add(commandsVer);
    commandsMenu.add(commandsUsers);
    commandsMenu.add(commandsSysInfo);

    programsMenu.add(programsFtp);
    programsMenu.add(programsTelnet);
    look_feelMenu.add(look_feelMetal);
    look_feelMenu.add(look_feelMotif);
    look_feelMenu.add(look_feelWindows);
    optionsMenu.add(look_feelMenu);

    aboutMenu.add(aboutVersion);

    // Admin
    adminMenu.add(adminAddUser);
    adminMenu.add(adminDelUser);
    adminMenu.add(adminGetUsers);
    adminMenu.setVisible(false);

    menuBar.add(fileMenu);
    menuBar.add(optionsMenu);
    menuBar.add(commandsMenu);
    menuBar.add(programsMenu);
    menuBar.add(adminMenu);
    menuBar.add(aboutMenu);
    setJMenuBar(menuBar);

    adminMenu.setEnabled(false);
    adminAddUser.setEnabled(false);
    adminDelUser.setEnabled(false);
  }

  void setShortCuts()
  {
    button_for_connection_.setMnemonic('C');
    button_for_clipboardcontrol_.setMnemonic('A');
    button_for_enter_url_.setMnemonic('E');
    button_for_update_linklist_.setMnemonic('R');
  }

  /** Fllt KontextMenu mit Eintrgen */
  void setupKontextMenu()
  {
    kontextMenu.add(kontextUpdate);
    kontextMenu.add(kontextReget);
    kontextMenu.add(kontextStop);
    kontextMenu.add(kontextRemove);
  }

  /** Meldet das DaunySocket etwas neues empfangen hat
 @param type spezifiziert Type von rmessage - 1 ... String; 2 ... Vector
 @param rmessage Nachrichtenobjekt
 */
  public void UpdateReceive(int type,Object rmessage)
  {
    switch (type)
    {
      case 0: // Update Empfangsliste
        m_dCMD.UpdateReceive((String)rmessage);
        break;
//		case 1: // Update einen Tabellen Eintrag
//				UpdateTableEntry(rmessage);
//				break;
//		case 2: // Update ganze Tabelle
//				tablemodel.setDataVector(m_dsSocket.showLinks(),columnames);
//				break;

    }

  }

  public void UpdateSend(int type,Object smessage)
  {
    switch (type)
    {
      case 0:m_dCMD.UpdateSend((String)smessage);break;
    }
  }


  /** ndert das Aussehen des Cursor
 @param which 0..default, 1..wait
 */
  void changeCursor(int which)
  {
    System.out.println("Change Cursor: "+which);
    switch (which)
    {
      case 0: setCursor(Cursor.DEFAULT_CURSOR);break;
      case 1: setCursor(Cursor.WAIT_CURSOR);break;
      default: setCursor(Cursor.DEFAULT_CURSOR);break;
    }
  }


  void Insert_in_Table(Link url)
  {
    //tablemodel.addRow(url.showLink());
    tablemodel.addLink(url);
  }

  void setupEventHandler()
  {
    MenuItemHandler menuListener = new MenuItemHandler();
    addWindowListener(new WindowHandler());

    idImport.addActionListener(menuListener);
    fileImport.addActionListener(menuListener);
    fileExport.addActionListener(menuListener);
    fileExit.addActionListener(menuListener);

    optionsServer.addActionListener(menuListener);
    optionsDownload.addActionListener(menuListener);
    optionsPrograms.addActionListener(menuListener);
    optionsPwd.addActionListener(menuListener);
    options_auto_update_.addActionListener(menuListener);

    commandsConnect.addActionListener(menuListener);
    commandsDisconnect.addActionListener(menuListener);
    commandsVar.addActionListener(menuListener);
    commandsVer.addActionListener(menuListener);
    commandsUsers.addActionListener(menuListener);
    commandsSysInfo.addActionListener(menuListener);
    commandsCMD.addActionListener(menuListener);
    commandsStore.addActionListener(menuListener);

    programsTelnet.addActionListener(menuListener);
    programsFtp.addActionListener(menuListener);

    look_feelMetal.addActionListener(menuListener);
    look_feelMotif.addActionListener(menuListener);
    look_feelWindows.addActionListener(menuListener);

    adminAddUser.addActionListener(menuListener);
    adminDelUser.addActionListener(menuListener);
    adminGetUsers.addActionListener(menuListener);

    aboutVersion.addActionListener(menuListener);

    ButtonHandler buttonListener = new ButtonHandler();
    button_for_clipboardcontrol_.addActionListener(buttonListener);
    button_for_enter_url_.addActionListener(buttonListener);
    button_for_reset_linklist_.addActionListener(buttonListener);
    button_for_update_linklist_.addActionListener(buttonListener);
    button_for_connection_.addActionListener(buttonListener);

    // KontextMenu
    urltable.addMouseListener(new MouseHandler());
    kontextUpdate.addActionListener(menuListener);
    kontextReget.addActionListener(menuListener);
    kontextStop.addActionListener(menuListener);
    kontextRemove.addActionListener(menuListener);

  }

  public void setOutput(int type,Object message)
  {
    String out="";
    switch (type)
    {
      case 0:	// Login -
        String title = "";
        switch (((Integer)message).intValue())
        {
          case 0: out = "To Server "+m_dsSocket.getServer()+" on Port "+m_dsSocket.getPort()+" connected";
            title = "Welcome";
            break;
          case 1: title="Error by login"; out = "Login failed. Check your login preferences !";break;
          case 2: title="Error by login"; out = "Login failed. User with this name is allready logged in !";break;
          case 3: title="Error by login"; out = "Login failed. This account was disabled !";break;
          default:
        }
        Message.showMessageDialog(this,out,title,Message.INFORMATION_MESSAGE);
        break;
      case 1: Message.showMessageDialog(this,(String)message,"Var",Message.INFORMATION_MESSAGE);break;
      case 2: Message.showMessageDialog(this,(String)message,"Users",Message.INFORMATION_MESSAGE);break;
      case 3: Message.showMessageDialog(this,(String)message,"Server",Message.INFORMATION_MESSAGE);break;
      case 4: Message.showMessageDialog(this,(String)message,"System",Message.INFORMATION_MESSAGE);break;
      case 5: // Disconnect
        Message.showMessageDialog(this,(String)message,"Disconnected",Message.INFORMATION_MESSAGE);
        adminMenu.setEnabled(false);
        adminMenu.setVisible(false);
        break;
      case 6: Message.showMessageDialog(this,(String)message,"Warning",Message.WARNING_MESSAGE);break;
      case 7: // Change Pwd
        boolean suxcess = ((Boolean)message).booleanValue();
        if (suxcess)
        {
          Message.showMessageDialog(this,"Password was successfully changed","Pwd Changed",Message.INFORMATION_MESSAGE);
        }
        else
        {
          Message.showMessageDialog(this,"Password was not changed","Pwd Changed",Message.INFORMATION_MESSAGE);
        }
        break;
      case 10:Message.showMessageDialog(this,(String)message,"Version",Message.INFORMATION_MESSAGE);break;
      case 100: Message.showMessageDialog(this,(String)message,"Error",Message.ERROR_MESSAGE);break;
      case 1006: // Admin Get Users
        java.util.Vector users = (java.util.Vector) message;
        String[][] outusers = new String [users.size()/4][4];
        for(int o=0;o<(users.size()/4);o++)
        {
          outusers [o][0] = (String)(users.get(4*o));
          outusers [o][1] = ((Boolean)(users.get((4*o)+1))).toString();
          outusers [o][2] = ((Boolean)(users.get((4*o)+2))).toString();
          outusers [o][3] = ((Boolean)(users.get((4*o)+3))).toString();
        }
        String[] columes =
        {"name","enabled","online","admin"
        };
        //tablemodel.setDataVector(outusers,columes);

        break;
      case 10000:// Admin Login
        out = "To Server "+m_dsSocket.getServer()+" on Port "+m_dsSocket.getPort()+" as admin connected";
        Message.showMessageDialog(this,out,"Welcome",Message.INFORMATION_MESSAGE);
        adminMenu.setEnabled(true);
        adminMenu.setVisible(true);
        break;
      default:
    }
  }

  String showInputDialog(String title, String question)
  {
    return Message.showInputDialog(this,question,title,Message.PLAIN_MESSAGE);

  }

  public static void main(String args[])
  {
    // System.out.println("Encrypt PWD: "+com.jdauny.DaunyNativeFunctions.encryptPassword("Helmut","1234567890098765432112345678900987654321"));
    DaunyGUI wnd = new DaunyGUI();
    // Logging
    try
    {
      java.io.OutputStream log_stream = (new java.io.FileOutputStream("dauny.log"));
      java.io.OutputStream error_stream = (new java.io.FileOutputStream("dauny.err"));
      Logger.addLoggingUnit(1,log_stream);
      Logger.addLoggingUnit(2,error_stream);
      Logger.setLoggingUnitPrefix(1,"log");
      Logger.setLoggingUnitPrefix(2,"err");
      java.util.BitSet config = new java.util.BitSet();
      config.set(1);
      config.set(2);
      // TimeStamp on
      Logger.switchOnConfigFlags(1,config);
      Logger.switchOnConfigFlags(2,config);
      Logger.enterLoggingState();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }

  }

  public void CloseApp()
  {
    m_dsSocket.SaveUserData();
    System.exit(0);
  }

  /** ndert Look & Feel Verhalten der Anwendung */
  public void changeLook_Feel(String which)
  {
    try
    {
      UIManager.setLookAndFeel(which);
      m_dDownload.changeLook_Feel(which);
      m_dServer.changeLook_Feel(which);
      m_dIDImport.changeLook_Feel(which);
      m_dPrograms.changeLook_Feel(which);
      m_dCMD.changeLook_Feel(which);
      m_dStore.changeLook_Feel(which);
//			m_Message.changeLook_Feel(which);
      SwingUtilities.updateComponentTreeUI(this);

    }
    catch(Exception E)
    {
      // Fehler beim Wechseln
      Message.showMessageDialog(this,"It was not possible to change correctly to the wanted style.","Error",Message.ERROR_MESSAGE);
    }
  }


  /** Lschen der Url-Tabelle
   * impliziert rcksetzten des DaunySockets - not busy, no transfers
   */
  public void ResetUrls()
  {
    int result = Message.showConfirmDialog(this,"Are you sure ?\nAll infos will be lost !","Reset Url-Table",Message.YES_NO_OPTION,Message.QUESTION_MESSAGE);
    System.out.println("Result: "+result);
    if (Message.YES_OPTION == result)
    {
      System.out.println("Reset");
      tablemodel.clearAll();
      m_dsSocket.Reset(true);
    }

  }

  public void InsertLink(String url)
  {
    Link newLink = new Link(url);
    Insert_in_Table(newLink);
    m_dsSocket.InsertLink(newLink);
  }

  public void LinkfromClipboard()
  {
    try
    {
      Clipboard clip = getToolkit().getSystemClipboard();
      Transferable cont = clip.getContents(this);
      if (cont != null)
      {
        String s = (String) cont.getTransferData(DataFlavor.stringFlavor);
        if(!s.equals(clipboard) && (s.startsWith("https://") || s.startsWith("http://") || s.startsWith("ftp://")))
        {
          System.out.println(s);
          clipboard = s;
        }
      }
    }
    catch(Exception E)
    {

    }
  }

  /** Kontrolliert auf KontextMenu und stellt dieses bei Bedarf da */
  public void checkKontextMenu(MouseEvent event)
  {
    if (event.isPopupTrigger())
    {
      //System.out.println("PopUP !!!"+urltable.rowAtPoint(event.getPoint()));
      int selected_row = urltable.rowAtPoint(event.getPoint());
      if(!urltable.isRowSelected(selected_row))
      {
        urltable.clearSelection();
        urltable.addRowSelectionInterval(selected_row,selected_row);
      }
      kontextMenu.show(event.getComponent(),event.getX(),event.getY());
    }
  }


  public String FileDialog(boolean open)
  {
    JFileChooser filediag = new JFileChooser();
    int check;
    String result = null;
    if (open)
    {
      check = filediag.showOpenDialog(this);
      if (check == JFileChooser.APPROVE_OPTION)
      {
        result = filediag.getSelectedFile().getPath();
      }
    }
    else
    {
      check = filediag.showSaveDialog(this);
      if (check == JFileChooser.APPROVE_OPTION)
      {
        result = filediag.getSelectedFile().getPath();
      }
    }
    return result;
  }

  void PlaySound()
  {
    clip.play();
  }

  // *********************************************
  // Inner Classes
  // =============
  //
  // for User and System interactions
  //
  // *********************************************

  // Beendet die Applikation
  public class WindowHandler extends WindowAdapter
  {
    public void windowClosing(WindowEvent e)
    {
      CloseApp();
    }
  }

  /** ActionListener fr Mouse - (Contextmenu) */
  public class MouseHandler implements MouseListener
  {

    public void mouseClicked(MouseEvent e)
    {
      checkKontextMenu(e);
    }

    public void mousePressed(MouseEvent e)
    {
      checkKontextMenu(e);
    }

    public void mouseReleased(MouseEvent e)
    {
      checkKontextMenu(e);
    }

    public void mouseEntered(MouseEvent e)
    {

    }

    public void mouseExited(MouseEvent e)
    {

    }

  }

  /** ActionListener fr Timer - Clipboard */
  public class TimerHandler implements ActionListener
  {
    public void actionPerformed(ActionEvent e)
    {
      //System.out.println("Timer: "+e.getActionCommand());
      try
      {
        Clipboard clip = getToolkit().getSystemClipboard();
        Transferable cont = clip.getContents(this);
        if (cont != null)
        {
          String s = (String) cont.getTransferData(DataFlavor.stringFlavor);
          if(!s.equals(clipboard) && (s.startsWith("http://") || s.startsWith("ftp://")))
          {
            //			System.out.println(s);
            InsertLink(s);
            PlaySound();
            m_dsSocket.requestGet();
          }
          clipboard = s;
        }
      }
      catch(Exception E)
      {

      }
    }
  }



  /**  ActionListener fr ButtonFunktionen */
  public class ButtonHandler implements ActionListener
  {
    public void actionPerformed(ActionEvent e)
    {
      String cmd = e.getActionCommand();
//			System.out.println("ButtonHandler");
      if(cmd.equals("get"))
      {
        String inputValue = showInputDialog("enter URL","Please input url:");
        if (inputValue!=null && inputValue.length()>3)
        {
          if (!(inputValue.startsWith("http://") || inputValue.startsWith("ftp://")))
          {
            inputValue = "http://"+inputValue;
          }
          InsertLink(inputValue);
          m_dsSocket.requestGet();
        }
      }
      if (cmd.equals("reset"))
      {
        ResetUrls();
//				tablemodel = new DefaultTableModel(m_dsSocket.showLinks(),columnames);
//        tablemodel = new LinkTableModel();
//        urltable.setModel(tablemodel);
      }
      if (cmd.equals("clipboard_off"))
      {
        try
        {
          Clipboard clip = getToolkit().getSystemClipboard();
          Transferable cont = clip.getContents(this);
          if (cont != null)
          {
            clipboard = (String) cont.getTransferData(DataFlavor.stringFlavor);
          }
          else
            clipboard = "";

        }
        catch(Exception E)
        {
          clipboard = "";
        }
        counter.start();// Timer
        button_for_clipboardcontrol_.setActionCommand("clipboard_on");
        button_for_clipboardcontrol_.setToolTipText("stop checking the clipboard [alt-a]");
        button_for_clipboardcontrol_.setIcon(getImageIcon("images/clipboard_on.gif"));
      }
      if (cmd.equals("clipboard_on"))
      {
        counter.stop();
        button_for_clipboardcontrol_.setActionCommand("clipboard_off");
        button_for_clipboardcontrol_.setToolTipText("check the clipboard [alt-a]");
        button_for_clipboardcontrol_.setIcon(getImageIcon("images/clipboard_off.gif"));
      }

      if (cmd.equals("update"))
      {
        m_dsSocket.requestUpdate();
      }

      if (cmd.equals("connect"))
      {
        changeCursor(1);
        m_dsSocket.Login();
        changeCursor(0);
      }

    }
  }

  /** Aktionlistener fr MenuFunktionen */
  public class MenuItemHandler implements ActionListener
  {
    public void actionPerformed(ActionEvent e)
    {
      String cmd = e.getActionCommand();
//			System.out.println("_"+cmd+"_");

      // Menu - File
      // ************

      if (cmd.equals("ID Import"))
      {
        System.out.println("ID _ Import");
        m_dIDImport.doModal();
        if (m_dIDImport.isOk())
        {
          Link new_link = new Link(m_dIDImport.m_sName ,m_dIDImport.m_iID,0,"");
          new_link.setType(-1);
          tablemodel.addLink(new_link);
          m_dsSocket.InsertLink(new_link);
        }
      }


      if (cmd.equals("Import"))
      {
        importLinks();
      }

      if (cmd.equals("Export"))
      {
        String result = FileDialog(false);
        if (result!=null)
        {
          //System.out.println(result);
          m_dsSocket.Links2File(0,0,result);
        }
      }



      if (cmd.equals("Exit"))
      {
        CloseApp();
      }

      // Menu - Options
      //****************
      if (cmd.equals("Server"))
      {
        m_dServer.m_sServer = m_dsSocket.getServer();
        m_dServer.m_iPort = m_dsSocket.getPort();
        m_dServer.m_sUser = m_dsSocket.getUser();
        m_dServer.m_sPwd = m_dsSocket.getPwd();
        m_dServer.m_bProxy = m_dsSocket.isProxy();
        m_dServer.m_sProxyServer = m_dsSocket.getProxyServer();
        m_dServer.m_iProxyPort = m_dsSocket.getProxyPort();

        m_dServer.doModal();
        if (m_dServer.isOk())
        {
          m_dsSocket.setServer(m_dServer.m_sServer,m_dServer.m_iPort,m_dServer.m_sUser,m_dServer.m_sPwd,m_dServer.m_bProxy,m_dServer.m_sProxyServer,m_dServer.m_iProxyPort);
        }
      }
      if (cmd.equals("Download"))
      {
        m_dDownload.m_sDir = m_dsSocket.getDir();
        m_dDownload.m_iRetries = m_dsSocket.getRetries();
        m_dDownload.m_iSame = m_dsSocket.getSame();
        m_dDownload.m_iPriority = m_dsSocket.getPriority();

        m_dDownload.doModal();
        if (m_dDownload.isOk())
        {
          m_dsSocket.setDownload(m_dDownload.m_sDir,m_dDownload.m_iRetries,m_dDownload.m_iSame,m_dDownload.m_iPriority);
        }
      }
      if (cmd.equals("Programs"))
      {
        m_dPrograms.m_sTelnet = m_dsSocket.getTelnet();
        m_dPrograms.m_sFtp = m_dsSocket.getFtp();

        m_dPrograms.doModal();
        if (m_dPrograms.isOk())
        {
          m_dsSocket.setPrograms(m_dPrograms.m_sFtp,m_dPrograms.m_sTelnet);
        }
      }

      if (cmd.equals("Change PWD"))
      {
        m_dChangePwd.doModal(m_dsSocket.getPwd());
        if (m_dChangePwd.isOk())
        {
          m_dsSocket.requestChangePWD(m_dChangePwd.getNewPwd());
        }
      }


      if(cmd.equals("Auto Update"))
      {
        showAutoUpdate();
      }

      // Menu - Commands
      //****************
      if (cmd.equals("Connect"))
      {
        changeCursor(1);
        m_dsSocket.Login();
        changeCursor(0);
      }
      if (cmd.equals("Disconnect"))
      {
        m_dsSocket.requestLogout();
        //	m_dsSocket.Close();
      }
      if (cmd.equals("VAR"))
      {
        m_dsSocket.requestServerStatus();
      }

      if (cmd.equals("USERS"))
      {
        m_dsSocket.requestUsers();
      }

      if (cmd.equals("VER"))
      {
        m_dsSocket.requestServerVersion();
      }

      if (cmd.equals("SYSINFO"))
      {
        m_dsSocket.requestSysInfo();
      }

      if (cmd.equals("CMD"))
      {
        m_dCMD.doModal();
      }

      if (cmd.equals("Store"))
      {
        m_dStore.doModal();
        if (m_dStore.isOk())
        {
          m_dsSocket.requestStore(m_dStore.m_sFilename,m_dStore.m_sInfo);
        }
      }

      if (cmd.equals("telnet"))
      {
        //System.out.println("telnet");
        try
        {
          String telnet = m_dsSocket.getTelnet();
          if(telnet.equals(""))
          {
            telnet = "telnet";
          }
          Runtime.getRuntime().exec(telnet);
        }
        catch (Exception me)
        {
          System.out.println("Error - opening program");
          System.out.println(me.toString());
        }
      }

      if (cmd.equals("ftp"))
      {
        //System.out.println("ftp");
        try
        {
          String ftp = m_dsSocket.getFtp();
          if(ftp.equals(""))
            ftp = "ftp";
          Runtime.getRuntime().exec(ftp);
        }
        catch (Exception me)
        {
          System.out.println("Error - opening program");
          System.err.println(me.toString());
        }
      }


      // Look and Feel
      // *************
      if(cmd.equals("Metal"))
      {
        String lookfeel = "javax.swing.plaf.metal.MetalLookAndFeel";
        changeLook_Feel(lookfeel);
      }

      if(cmd.equals("Motif"))
      {
        String lookfeel = "com.sun.java.swing.plaf.motif.MotifLookAndFeel";
        changeLook_Feel(lookfeel);
      }

      if(cmd.equals("Windows"))
      {
        String lookfeel = "com.sun.java.swing.plaf.windows.WindowsLookAndFeel";
        changeLook_Feel(lookfeel);
      }

      //Admin
      //*****
      if (cmd.equals("Add User"))
      {
   /*	String inputValue = showGetDialog();
    if(inputValue!=null && inputValue.length()>3)
    InsertLink(inputValue);
    m_dsSocket.requestGet();
   */
        //System.out.println("AddUser");
      }

      if (cmd.equals("Delete User"))
      {
   /*	String inputValue = showGetDialog();
    if(inputValue!=null && inputValue.length()>3)
    InsertLink(inputValue);
    m_dsSocket.requestGet();
   */
        //System.out.println("DelUser");
      }

      if (cmd.equals("Get Users"))
      {
   /*	String inputValue = showGetDialog();
    if(inputValue!=null && inputValue.length()>3)
    InsertLink(inputValue);
    m_dsSocket.requestGet();
   */
        m_dsSocket.getUsers();
        //System.out.println("Get Users");
      }


      // About
      // *****
      if (cmd.equals("Version"))
      {
        setOutput(10,"JDauny\nVersion "+VERSION+"\n"+VERSIONTIME+"\nprogrammed by H. Adam");
      }

      // KontextMenu
      // ***********
      int[] selected_rows = urltable.getSelectedRows();
      if (cmd.equals("kontext_update"))
      {
        //System.out.println("Update Row "+selected_row);
        m_dsSocket.requestUpdate(selected_rows);
      }
      if (cmd.equals("kontext_reget"))
      {
        //System.out.println("Reget Row "+selected_row);
        for(int row=0;row<selected_rows.length;row++)
          m_dsSocket.requestReget(selected_rows[row]);
      }
      if (cmd.equals("kontext_stop"))
      {
        //System.out.println("Stop Row "+selected_row);
        for(int row=0;row<selected_rows.length;row++)
          m_dsSocket.requestStop(selected_rows[row]);
      }
      if (cmd.equals("kontext_remove"))
      {
        //System.out.println("Stop Row "+selected_row);
        for(int row=0;row<selected_rows.length;row++)
          m_dsSocket.requestRemoveFile(selected_rows[row]);
      }

    }
  }


  public void setBusy(boolean busy)
  {
    System.out.println("Busy: "+busy);
    if(busy)
    {
      changeCursor(1);
    }
    else
    {
      changeCursor(0);
    }
  }

  protected void importLinks()
  {
    String result = FileDialog(true);
    if (result!=null)
    {
      int question = Message.showConfirmDialog(this,"Soll der Name der Textdatei als Verzeichnisname verwendet werden?","Downloadverzeichnis",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE );
      if(question == JOptionPane.YES_OPTION)
      {
        java.io.File test;
        int path_index = result.lastIndexOf(java.io.File.separator);
        int ext_index = result.lastIndexOf('.');
        String new_dir = result;
        if(path_index>=0)
        {
          if(ext_index>=0)
            new_dir = result.substring(path_index+1,ext_index);
          else
            new_dir = result.substring(path_index+1);
        }
//        System.out.println(new_dir);
        m_dsSocket.File2Links(0,0,result,new_dir);
      }
      else
      {
        m_dsSocket.File2Links(0,0,result,m_dsSocket.getDir());
      }
      UpdateReceive(2,null);
      java.util.Enumeration all_links = m_dsSocket.getLinks();
      while(all_links.hasMoreElements())
      {
        tablemodel.addLink(((Link)all_links.nextElement()));
      }
      m_dsSocket.requestGet();
    }
  }

  protected void showAutoUpdate()
  {
    System.out.println("Auto Update");
  }

}