package com.jdauny.client;
import java.util.*;
//import com.jdauny.client.*;


public class DaunyWeb implements DaunyOutput
{
	DaunySocket m_dsocket;
	boolean m_bReceive;
	boolean m_bAdmin;
	Thread m_tSleep;
	int m_iError = 0;
	String m_sResult;
	Vector m_vResult;
	String m_sLastUrl;


	public DaunyWeb()
	{
		m_dsocket = new DaunySocket(this,false);
		m_tSleep = new Thread();
		m_sLastUrl = "";
		m_bReceive = false;
		m_bAdmin = false;
	}

	/** Liest die Daten des Users aus einem File
	*/
	public void openSaveFile(String saveFile)
	{
		m_dsocket.setSaveFile(saveFile);
		m_dsocket.ReadUserData();
	}

	/** Speichert Daten des Users in ein File ausgenommen Admin
	*/
	public void writeSaveFile(String saveFile)
	{
		if (!m_bAdmin)
		{
			m_dsocket.setSaveFile(saveFile);
			m_dsocket.SaveUserData();
		}
	}

	/** Setzt die Informationen der Downloads zurck
	*/
	public void Reset()
	{
		m_dsocket.Reset(true);
	}

	/** Setzt Serverinformationen
	@param server Adresse des Servers
	@param port Portnummer des Servers
	@param user Username
	@param pwd Pawort
	*/
	public void setServer(String server,int port,String user,String pwd)
	{
		m_dsocket.setServer(server,port,user,pwd,false,"",0);
	}

	/** Setzt Download Inforamtionen
	@param dir Relatives Verzeichnis in das der Download gespeichert werden soll
	@param retries Anzahl der Downloadversuche
	@param same Gibt an wieviele Downloads von einem Server zur gleichen Zeit gestartet werden sollen
	@param priority Legt die Prioritt des Downloads fest
	*/
	public void setDownload(String dir,int retries,int same,int priority)
	{
		m_dsocket.setDownload(dir,retries,same,priority);
	}

	public String getServer()
	{
		return m_dsocket.getServer();
	}

	public int getPort()
	{
		return m_dsocket.getPort();
	}

	public String getUser()
	{
		return m_dsocket.getUser();
	}

	public String getPwd()
	{
		return m_dsocket.getPwd();
	}

	public String getDir()
	{
		return m_dsocket.getDir();
	}

	public int getSame()
	{
		return m_dsocket.getSame();
	}

	public int getPriority()
	{
		return m_dsocket.getPriority();
	}

	public int getRetries()
	{
		return m_dsocket.getRetries();
	}

	public Enumeration getLinks()
	{
		return m_dsocket.getLinks();
	}

	public boolean isLogged_in()
	{
		return m_dsocket.isLogged_in();
	}

	public String getLastUrl()
	{
		return m_sLastUrl;
	}

	/** Wartet auf Nachricht vom Server */
	private void Wait()
	{
		while (!m_bReceive)
		{
			System.out.println("while");
			try
			{
				m_tSleep.sleep(500);
			}
			catch(Exception E)
			{
				System.out.println(E.toString());
			}
		}
	}

	/** Startet einen Loginversuch
	*/
	public int Login()
	{
		m_bReceive = false;
		m_bAdmin = false;
		m_dsocket.Login();
		Wait();
/*		if(m_iError==0)
			m_dsocket.Reset(true);
*/
		System.out.println(isLogged_in());
		return m_iError;
	}

	/** Loggt sich beim Server aus
	*/
	public int Logout()
	{
		if (m_dsocket.isLogged_in())
		{
			m_bReceive = false;
			m_dsocket.requestLogout();
			Wait();
			m_dsocket.Close();
		}
		return m_iError;
	}

	/**  ndert das Pwd
	@param newpwd neues Passwort
	*/
	public int changePwd(String newpwd)
	{
		if (m_dsocket.isLogged_in())
		{
			m_bReceive = false;
			m_dsocket.requestChangePWD(newpwd);
			Wait();
			return m_iError;
		}
		else
			return 1;
	}


	/** Fgt neuen Links hinzu
	@param url Url des neuen Links
	*/
	public void InsertLink(String url)
	{
		if (!url.startsWith("http://") && !url.startsWith("ftp://"))
		{
			url = "http://"+url;
		}
		m_dsocket.InsertLink(url);
//		if (m_dsocket.isLogged_in())
//		{
//			m_bReceive = false;
			m_dsocket.requestGet();
			m_sLastUrl = url;
//			Wait();
//		}
	}

	/** Stop die Downloads mit den angebene ID's
	@param toStop String array der ID's
	*/
	public void Stop(String[] toStop)
	{
		Vector Parameter = new Vector();
		for(int i=0;i<toStop.length;i++)
		{
			Parameter.add(new Integer(toStop[i]));
		}
		m_dsocket.requestStop(Parameter);
	}

	/** Aktualisiert die Informationen der Links
	*/
	public void Update()
	{
		if (m_dsocket.isLogged_in())
		{
			m_bReceive = false;
			m_dsocket.requestUpdate();
			Wait();
		}
	}

	/** Fordert bergebene ID nochmal an - reget
	@param toReget Feld mit Ids
	*/
	public void Reget(String[] toReget)
	{
		try
		{
			Vector Parameter = new Vector();
			for(int i=0;i<toReget.length;i++)
			{
				Parameter.add(new Integer(toReget[i]));
			}
			m_dsocket.requestReget(Parameter);
			Wait();
		}
		catch(Exception E)
		{

		}
	}

	/** Fragt Server auf seinen Status ab
	*/
	public String getServerStatus()
	{
 		m_sResult = "";
		if (m_dsocket.isLogged_in())
		{
			m_bReceive = false;
			m_dsocket.requestServerStatus();
			Wait();
		}
		return prepareString(m_sResult);
	}

	/** Fragt Systeminfo des Servers ab
	*/
	public String getSysInfo()
	{
 		m_sResult = "";
		if (m_dsocket.isLogged_in())
		{
			m_bReceive = false;
			m_dsocket.requestSysInfo();
			Wait();
		}
		return prepareString(m_sResult);
	}

	public void setOutput(int type,Object message)
	{
		switch (type)
		{
		case 0:	//Login - suxcess
				m_iError = (((Integer)message).intValue());
				break;
		case 1: // ServerStatus
 				m_sResult = (String) message;
				break;
		case 2: // Users Online
				m_sResult = (String) message;
				break;
		case 3: // Server Version
				m_sResult = (String) message;
				break;
		case 4: // SysInfo
				m_sResult = (String) message;
				break;
	/*
		case 5:
				Message.showMessageDialog(this,(String)message,"Disconneted",Message.INFORMATION_MESSAGE);break;

		case 6: Message.showMessageDialog(this,(String)message,"Warning",Message.WARNING_MESSAGE);break;
		case 10:Message.showMessageDialog(this,(String)message,"Version",Message.INFORMATION_MESSAGE);break;
	*/
		case 100:  // no server was found
				   m_iError = -1;
				   break;

		case 7: // Change Pwd
				boolean suxcess = ((Boolean)message).booleanValue();
				if(suxcess)
					m_iError = 0;
				else
					m_iError = 1;
				break;


		//*** ADMIN ***
		case 1000:
		    //AddUser - suxcess
		    m_iError=((Integer)message).intValue(); //leitet den Errorcode an die JSP weiter.
		    break;

		case 1001:
		    //DelUser - suxcess
		    m_iError=((Integer)message).intValue(); //leitet den Errorcode an die JSP weiter.
		    break;

		case 1002: // LinkList
		    m_vResult=(Vector)message; //leitet einen Vector mit den Links an die JSP weiter.
		    break;

		case 1003:
		    //DelDownload - suxcess
		    m_iError=((Integer)message).intValue(); //leitet den Errorcode an die JSP weiter.
		    break;
		case 1004:
		    //SetMaxDownloads - suxcess
		    m_iError=((Integer)message).intValue(); //leitet den Errorcode an die JSP weiter.
		    break;
		case 1005:
		    //GetMaxDownloads - suxcess
		    m_iError=((Integer)message).intValue(); //leitet den Errorcode an die JSP weiter.
		    break;
		case 1006:
		    //DelDownload - suxcess
		    m_vResult=(Vector)message; //leitet einen Vector mit den Users an die JSP weiter.
		    break;
		case 1007:
		    //DelDownload - suxcess
		    m_iError=((Integer)message).intValue(); //leitet den Errorcode an die JSP weiter.
		    break;

		case 10000: // Admin Login
		    m_bAdmin = true;
			m_iError = 0;
		    break;
		//*** ADMIN ENDE ***

		default:
		}
		if(!m_bReceive)	m_bReceive = true;
	}

	public void UpdateSend(int type,Object message)
	{

	}

	public void UpdateReceive(int type,Object message)
	{
		if(!m_bReceive)	m_bReceive = true;
	}

	String prepareString(String toprepare)
	{
		String result="";
		int a,b;
		a = b = 0;
		while ((b=toprepare.indexOf("\n",a))>=0)
		{
			result = result + toprepare.substring(a,b) + "<br>";
			a=b+1;
		}
		if(result.equals(""))
			result = toprepare;
		return result;
	}

	// *************
	// *** ADMIN ***
	// *************
    public int addUser(String username,String passwd,String adminUser)
    {
		m_bReceive = false;
		m_dsocket.addUser(username,passwd,adminUser);
		Wait();
		return m_iError;
    }

    public int delUser(String username)
    {
		m_bReceive = false;
		m_dsocket.delUser(username);
		Wait();
		return m_iError;
    }

    public Vector getDownloads(String username)
    {
		m_bReceive = false;
		m_dsocket.getLinks(username);
		Wait();
		return m_vResult;
    }

    public int delDownload(String downloadid)
    {
		m_bReceive = false;
		m_dsocket.delDownload(downloadid);
		Wait();
		return m_iError;
    }

	/** Delete Downloads mit den angebene ID's
	@param toDelete String array der ID's
	*/
	public int delDownload(String[] toDelete)
	{
		try
		{
			Vector Parameter = new Vector();
			for(int i=0;i<toDelete.length;i++)
			{
				Parameter.add(new Integer(toDelete[i]));
			}
			m_dsocket.delDownload(Parameter);
			Wait();
		}
		catch(Exception E)
		{
			m_iError = 100;
		}
		return m_iError;
	}

    public int setMaxDownloads(String number)
    {
		m_bReceive = false;
		m_dsocket.setMaxDownloads(number);
		Wait();
		return m_iError;
    }

    public int getMaxDownloads()
    {
		m_bReceive = false;
		m_dsocket.getMaxDownloads();
		Wait();
		return m_iError;
    }


    public Vector getUsers()
    {
		m_bReceive = false;
		m_dsocket.getUsers();
		Wait();
		return m_vResult;
    }



    public int userEnable(String username,String enable)
    {
		m_bReceive = false;
		m_dsocket.userEnable(username,enable);
		Wait();
		return m_iError;
    }

    public boolean isAdmin()
    {
		return m_bAdmin;
    }
	// ******************
    // *** ADMIN ENDE ***
	// ******************

	public static void main(String args[])
	{
		DaunyWeb test = new DaunyWeb();
		//System.out.println(test.prepareString("hallo\nwie\ngehts\ndenn\nso"));
		test.setServer("localhost",5565,"bernhard","bernhard");
		System.out.println(">>>>>>>>>>>>>>>>>>>>>");
		System.out.println("connected: "+test.Login());
		System.out.println(">>>>>>>>>>>>>>>>>>>>>");
		System.out.println("SysInfo: "+test.getSysInfo());
		String[] toStop = {"1","2","3","4"};
		test.Stop(toStop);
// 		System.out.println("serverinfo: "+test.getServerStatus());
//		System.out.println(">>>>>>>>>>>>>>>>>>>>>");
//		System.out.println("Downloads: "+test.getDownloads("king"));
//
//		test.InsertLink("http://www.google.de");
// 		System.out.println("serverinfo: "+test.getServerStatus());
//		test.InsertLink("http://www.google.com");
//		System.out.println("serverinfo: "+test.getServerStatus());
//		System.out.println("DelDownload: "+test.delDownload("2"));
//		System.out.println(">>>>>>>>>>>>>>>>>>>>>");
//		System.out.println("Downloads: "+test.getDownloads("king"));

		test = null;
	}

        public void setBusy(boolean busy)
        {

        }
}