package com.jdauny.client;

import java.util.*;
import javax.swing.*;
import javax.swing.table.*;
import com.jdauny.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class LinkTableModel extends AbstractTableModel implements Observer
{
  public static final int PRECISION = 3;
  // holds the strings to be displayed in the column headers of our table
  final String[] columnNames = {"ID","Filename","Filesize","State","Progress"};
  // holds the data types for all our columns
  final Class[] columnClasses = {Integer.class, String.class, Integer.class, String.class, JProgressBar.class};
  // holds our data
  final Vector data = new Vector();

  // adds a row
  public void addLink(Link newLink)
  {
    if(data.contains(newLink))
      return;
    data.addElement(newLink);
    newLink.addObserver(this);
    fireTableRowsInserted(data.size()-1,data.size()-1);
  }

  public void clearAll()
  {
    data.clear();
    fireTableDataChanged();
  }

  // is called by a link object when its state change
  public void update(Observable observable, Object link)
  {
      int index = data.indexOf(link);
      if(index != -1)
      {
        fireTableRowsUpdated(index,index);
      }
  }

  public int getColumnCount()
  {
      return columnNames.length;
  }

  public int getRowCount()
  {
      return data.size();
  }

  public String getColumnName(int col)
  {
      return columnNames[col];
  }

  public Class getColumnClass(int c)
  {
      return columnClasses[c];
  }

  public Object getValueAt(int row, int col)
  {
      Link link = (Link) data.elementAt(row);
      switch(col)
      {
      case 0: return new Integer(link.getID());
      case 1: return link.getFileName();
      case 2: int size = link.getSize();
              if(size<1024)
                return(Real2String(size,PRECISION)+" b");
              if(size<(1024*1024))
                return(Real2String(size/1024f,PRECISION)+" kB");
              return(Real2String(size/(1024f*1024f),PRECISION)+" MB");
      case 3: return link.getState();
      case 4: return link.getError();
      case 5: return new Float(link.getProgress());
      default:return null;
      }
  }

  protected String Real2String(float value,int precision)
  {
    String result = String.valueOf(value);
    int comma_index = result.lastIndexOf('.');
    if(result.length() >= comma_index+precision+1 && comma_index >= 0)
    {
      result = result.substring(0,comma_index+precision+1);
    }
    return result;
  }

  public boolean isCellEditable(int row, int col)
  {
        return false;
  }
}