package com.jdauny.client;
import java.io.*;
public class SocketListener extends Thread
{
  InputStream m_IN;
  ObjectInputStream m_obIN;
  Socket_Com m_Smaster;
  boolean m_bListen;
  boolean m_bCReceive;

  public SocketListener(Socket_Com master,boolean classreceive,InputStream in)
  {
    try
    {
      m_IN = in;
      m_bCReceive = classreceive;
      if (m_bCReceive)
      {
        m_obIN = new ObjectInputStream(m_IN);
        logger.Logger.log(1,"using classprotocoll");
      }
      else
      {
        m_obIN = null;
      }
    }
    catch(Exception E)
    {
      logger.Logger.log(2,"no java server");
      logger.Logger.log(1,"using textprotocoll");
      m_obIN = null;
      m_bCReceive = false;
      master.setClassSend(false);
    }
    m_Smaster = master;
  }

  /** Wartet auf neue Nachrichten vom Server*/
  public void Receive()
  {
    while (!isInterrupted())
    {
      try
      {
        if (m_bCReceive)
        {
          com.jdauny.DaunyMessage o_message = (com.jdauny.DaunyMessage) m_obIN.readObject();
          logger.Logger.log(1,"receive: "+o_message.toString());
          //					System.out.println("Receive:\n*********\n"+o_message.getParameters()+"\n-------------");
          m_Smaster.OnReceive(o_message);
        }
        else
        {
          byte buff[] = new byte[4096];
          int len;
          if((len=m_IN.read(buff))!=-1)
          {
            String answer = new String(buff,0,len-1);
            logger.Logger.log(1,"receive: "+answer);
            m_Smaster.OnReceive(answer);
          }
          else
          {
            m_bListen = false;
            m_Smaster.Close();
            logger.Logger.log(2,"close connection");
            break;
          }
        }
      }
      catch(Exception E)
      {
        //System.out.println("SocketListener-Error: ");
        //E.printStackTrace();
        if (true)//E.toString().equals("java.net.SocketException: Socket closed"))
        {
//					System.out.println("Server Closed Socket");
          logger.Logger.log(2,"close connection");
          m_Smaster.Close();
          break;
        }

      }
    }
  }

  /** Stop den SocketListener - keine Nachrichten werden mehr empfangen*/
  public synchronized void Stop()
  {
    try
    {
      m_bListen = false;
      m_IN.close();
    }
    catch(Exception E)
    {
//			System.out.println("-> Error Thread closing!");
    }
  }

  public void run()
  {
    m_bListen = true;
    Receive();
  }
}