package com.jdauny.client;
import java.io.*;
import java.net.Socket;
import com.jdauny.DaunyMessage;

public abstract class Socket_Com
{
  boolean m_bListen;
  boolean m_bConnected;
  // Gibt an ob ber Klassen oder Strings kommuniziert wird
  boolean m_bCSend = true;
//	boolean m_bCSend = false;
  InputStream m_IN;
  OutputStream m_OUT;
  ObjectOutputStream m_obOUT;
  Socket m_Socket;
  SocketListener m_SocketListener;

  /** ffnet neue Verbindung mit einem Server
 @param m_sServer Adresse des Servers
 @param m_iPort Portnummer des Servers
 */
  public boolean Open(String m_sServer,int m_iPort)
  {
    boolean result = false;
    for(int i=0;i<1;i++)
    {
      try
      {
        boolean help = m_bCSend;
        m_Socket = new Socket(m_sServer,m_iPort+i);
        m_Socket.setKeepAlive(true);
        m_IN = m_Socket.getInputStream();
        m_OUT = m_Socket.getOutputStream();
        if (m_bCSend)
        {
          m_obOUT = new ObjectOutputStream(m_OUT);
        }
        else
        {
          m_obOUT = null;
        }
        m_SocketListener = new SocketListener(this,m_bCSend,m_IN);
        m_bListen = true;
        m_bConnected = true;
        result = true;
        if (help!=m_bCSend)
        {
          m_Socket.close();
          Thread.currentThread().sleep(1000);
          System.out.println("Switching to TextMode");
          result = Open(m_sServer,m_iPort);
          break;
        }
        m_SocketListener.start();
        break;
      }
      catch(Exception E)
      {
        E.printStackTrace();
        m_bConnected = false;
        try
        {

        }
        catch(Exception e)
        {

        }
//				System.out.println(E.toString());
      }
    }
    return result;
  }

  /** Abstrakte Methode - wird aufgerufen wenn neue Nachricht empfangen wurde - TextMode
 @param message Erhaltene Nachricht
 */
  abstract void OnReceive(String message);

  /** Abstrakte Methode - wird aufgerufen wenn neue Nachricht empfangen wurde - ClassMode
 @param message Erhaltene Nachricht
 */
  abstract void OnReceive(com.jdauny.DaunyMessage message);

  /** Abstrakte Methode - wird aufgerufen wenn die Verbindung mit dem Server unterbrochen wurde
   */
  abstract void OnClose();

  /** Sendet eine Nachricht zum Server - TextMode
 @param message die zu schickende Nachricht
 */
  void Send(String message)
  {
    try
    {
      message = message+"\0";
      logger.Logger.log(1,"send: "+message);
      BufferedWriter writeOut = new BufferedWriter(new OutputStreamWriter(m_OUT));
      writeOut.write(message,0,message.length());
      writeOut.flush();
    }
    catch(Exception E)
    {
//			System.out.println(E.toString());
    }
  }

  /** Sendet eine Nachricht zum Server - ClassMode
 @param message die zu schickende Nachricht
 */
  void Send(com.jdauny.DaunyMessage message)
  {
    try
    {
//			outputMessage(message);
      logger.Logger.log(1,"send: "+message);
      m_obOUT.writeObject(message);
      m_obOUT.flush();
    }
    catch(Exception E)
    {
//			System.out.println(E.toString());
    }
  }

  /** Hat nur Debug Funktionen - gibt Inhalt einer Message aus - ClassMode
   */
  void outputMessage(DaunyMessage message)
  {
    System.out.println("++++++++++++++");
    System.out.println("Send:\n----------");
    System.out.println("MessageType = "+message.getType());
    System.out.println("ID: "+message.getID()+"\nSuxcess: "+message.getSuxcess()+"\nParameters: "+message.getParameters());
    System.out.println("++++++++++++++");
  }


  /** Beendet die Kommunikation mit dem Server
   */
  public void Close()
  {
    try
    {
      m_bConnected = false;
      m_SocketListener.Stop();
      m_Socket.shutdownInput();
      m_Socket.shutdownOutput();
      m_IN.close();
      m_OUT.close();
      m_Socket.close();
      OnClose();
    }
    catch(Exception e)
    {
//			System.out.println(e.toString());
    }
  }

  /** Setzt KlassMode oder TextMode
 @param mode true - Klassenmodus, false - Textmodus
 */
  public void setClassSend(boolean mode)
  {
    m_bCSend = mode;
  }

  /** Knnen Klassen gesendet werden*/
  public boolean getClassSend()
  {
    return m_bCSend;
  }
}