package com.jdauny.client;
import java.io.*;
import java.util.*;
import com.jdauny.*;

/** Diese Klasse beinhaltet alle zu speichernden UserInfos */
public class UserDat implements Serializable
{
	Vector m_vLinks;
	String m_sUser="";
	String m_sPwd="";
	String m_sServer="duni.prangl.net";//[] = new String[6];
	String m_sProxyServer="";
	int m_iPort=5565;//[] = new int[6]
	int m_iProxyPort=80;
	boolean m_bProxy=false;
	String m_sFtp="";
	String m_sTelnet="";
	String m_sDir="";
	int m_iRetries=9;
	int m_iSame=9;
	int m_iPriority=5;

	/** Konstruktor
	*/
	public UserDat()
	{
		m_vLinks = new Vector();
	}

	/** Fgt neuen Link in UserDat ein */
	public void addLink(Link newLink)
	{
		newLink.setLinkInfo(m_sDir,m_iRetries,m_iSame,m_iPriority);
		m_vLinks.add(newLink);
	}

	/** Fgt neuen Link in UserDat ein */
	public void addLink(String linkurl)
	{
		addLink(new Link(linkurl));
	}

	/** Fgt einen Vector voller Links ein
	@param start Position ab der der Vector eingefgt wird
	@param linkvector einzufgender Vector
	*/
	public void addLinkVector(int start,Vector linkvector)
	{
		m_vLinks.addAll(start,linkvector);
	}

        public void updateLinks(int start,Vector linkvector)
        {
             Enumeration new_link_enum = linkvector.elements();
             int counter = start;
             Link helpLink = null;
             Link actLink = null;
             while(new_link_enum.hasMoreElements() && counter<m_vLinks.size())
             {
                  helpLink = (Link) new_link_enum.nextElement();
                  System.out.println("New Link: " + helpLink);
                  if(helpLink != null)
                  {
                      actLink = (Link) m_vLinks.get(counter);
                      actLink.setInfoas(helpLink);
                      counter++;
                  }
             }
        }

        public void updateLinks(Vector linkvector)
        {
              Enumeration new_link_enum = linkvector.elements();
              Enumeration old_link_enum = m_vLinks.elements();
              Link helpLink = null;
              Link actLink = null;
              while(new_link_enum.hasMoreElements() && old_link_enum.hasMoreElements())
              {
                  helpLink = (Link) new_link_enum.nextElement();
                  if(helpLink != null)
                  {
                    do
                    {
                      actLink = (Link) old_link_enum.nextElement();
                    }
                    while(!actLink.equals(helpLink) && old_link_enum.hasMoreElements());
                    if(actLink.equals(helpLink))
                      actLink.setInfoas(helpLink);
                  }
              }
        }

	/** Entfernt Links
	@param start Startindex
	@param end Endindex
	*/
	public void removeLinks(int start,int end)
	{
		for(int i=start;i<=end;i++)
			m_vLinks.removeElementAt(start);
	}

	/** Sucht und setzt bei erfolgreicher Suche die Informationen wie im bergebenen Link
	*/
	public boolean FindandReplace(Link newlink)
	{
		boolean result = false;
		Link thislink;
		for(int i=0;i<m_vLinks.size();i++)
		{
			thislink = (Link) m_vLinks.get(i);
			if(thislink.HasID(newlink.getID()))
			{
				result = true;
				thislink.setInfoas(newlink);
				i = m_vLinks.size()+1;
			}
		}
		return result;
	}

	/** Liefert die Anzahl der in UserDat gespeicherten Links zurck */
	public int numberofLinks()
	{
		return m_vLinks.size();
	}

	/** Liefert den i. eingefgten Link zurck */
	public Link getLink(int which)
	{
          return (Link) m_vLinks.get(which);
	}

        public Link getLinkWithId(int id)
        {
          Link actual;
          for(int index=0;index<m_vLinks.size();index++)
          {
            actual = (Link)m_vLinks.get(index);
            if(actual.getID()==id)
              return actual;
          }
          return null;
        }

	/** Ersetzt den i. Link mit newlink
	@param i Nummer des zu ersetzenden Links
	@param newlink neuer Link
	*/
	public void replaceLink(int i,Link newlink)
	{
		m_vLinks.setElementAt(newlink,i);
	}

	/** Gibt alle Links mittels einer Enumeration zurck */
	public Enumeration getLinks()
	{
		return m_vLinks.elements();
	}

	/** Enfernt alle Links aus UserDat */
	public void emptyLinks()
	{
		m_vLinks.removeAllElements();
	}

	/** Importiert Links aus einer Datei */
	public boolean File2Links(int mode, int which,String filename,String directory)
	{
		boolean result = false;
		try
		{
			switch (which)
			{
			case (0):
				BufferedReader readstream = new BufferedReader(new FileReader(new File(filename)));
				String thisurl;
                                String temp_dir = m_sDir;
                                m_sDir = directory;
				while ((thisurl=readstream.readLine())!=null)
				{
					if (thisurl.startsWith("http://") || thisurl.startsWith("ftp://"))
					{
						addLink(thisurl);
					}
				}
				readstream.close();
                                m_sDir = temp_dir;
				break;
			default:
			}
			result = true;
		}
		catch(Exception E)
		{
			result = false;
		}
		return result;
	}

	/** Speichert Links in eine Datei */
	public boolean Links2File(int mode, int which,String filename)
	{
		boolean result = false;
		try
		{
			Enumeration all_links = getLinks();
			Link thislink;
			FileWriter filestream = new FileWriter(new File(filename));
			BufferedWriter writestream = new BufferedWriter(filestream);
			while (all_links.hasMoreElements())
			{
				thislink = (Link) all_links.nextElement();
				switch (which)
				{
				case (0): //alle Links
							writestream.write(thislink.getUrl());
							writestream.newLine();
							break;
				}
			}
			writestream.flush();
			writestream.close();
		}
		catch(Exception E)
		{
			result = false;
		}
		return result;
	}

	/** Setzt die Informationen fr den Download
	* @param dir Verzeichnis in das das File gespeichert wird
	* @param retries Anzahl der Downloadversuche
	* @param same Anzahl der parallel durchgefhrten Downloads vom gleichen Server
	* @param priority Prioritt des Download
	*/
	public void setDownloadInfo(String dir,int retries,int same,int priority)
	{
		m_sDir = dir;
		m_iRetries = retries;
		m_iSame = same;
		m_iPriority = priority;
	}

	/** Setzt Serverinformation
	* @param server Serveradresse
	* @param port Port des Server
	* @param user Loginname des Users
	* @param pwd Passwort des Users
	* @param proxy Verbindung ber Proxy
	* @param proxyserver Proxyadresse
	* @param proxyport ProxyPort
	*/
	public void setServerInfo(String server,int port,String user,String pwd,boolean proxy,String proxyserver,int proxyport)
	{
		m_sServer = server;
		m_iPort = port;
		m_sUser = user;
		m_sPwd = pwd;
		m_bProxy = proxy;
		m_sProxyServer = proxyserver;
		m_iProxyPort = proxyport;
	}

	/** Setzt Programmpfade fr ftp und Telnet */
	public void setPrograms(String ftp,String telnet)
	{
		m_sFtp = ftp;
		m_sTelnet = telnet;
	}

	/** Liefert den Usernamen
	*/
	public String getUser()
	{
		return m_sUser;
	}

	/** Setzt Pawort neu
	@param newpwd neues Pawort
	*/
	public void setPwd(String newpwd)
	{
		m_sPwd = newpwd;
	}

	/** Liefert das Pawort
	*/
	public String getPwd()
	{
		return m_sPwd;
	}

	/** Liefert die Serveradresse
	*/
	public String getServer()
	{
		return m_sServer;
	}

	/** Liefert den Serverport
	*/
	public int getPort()
	{
		return m_iPort;
	}

	/** berprft ob Kommunikation ber einen Proxyserver erfolgen soll
	*/
	public boolean isProxy()
	{
		return m_bProxy;
	}

	/** Liefert die Adresse des eingestellten Proxyservers
	*/
	public String getProxyServer()
	{
		return m_sProxyServer;
	}

	/** Liefert die Portnummer des eingestellen Proxyservers
	*/
	public int getProxyPort()
	{
		return m_iProxyPort;
	}

	/** Liefert den als Telnetclient spezifizierten Programmpfad
	*/
	public String getTelnet()
	{
		return m_sTelnet;
	}

	/** Liefert den als Fftpclient spezifizierten Programmpfad
	*/
	public String getFtp()
	{
		return m_sFtp;
	}

	/** Liefert den aktuell eingestellten Namen des Downloadverzeichnis zurck
	*/
	public String getDir()
	{
		return m_sDir;
	}

	/** Liefert die aktuell eingestellte Anzahl der Downloadversuche
	*/
	public int getRetries()
	{
		return m_iRetries;
	}

	/** Liefert die aktuell eingestellte Anzahl der gleichzeitigen Downloads von einem Server
	*/
	public int getSame()
	{
		return m_iSame;
	}

	/** Liefert die aktuell eingestellte Prioritt
	*/
	public int getPriority()
	{
		return m_iPriority;
	}

	/** Liefert eine Reprsentation aller gespeicherten Links (darstellen der Links in einer Tabelle)
	*/
	public Object[][] showLinks()
	{
		int size = m_vLinks.size();
		Enumeration linkdata = getLinks();
		String[][] result = new String[size][4];
	 	for(int i=0;linkdata.hasMoreElements();i++)
	 	{
			result[i] = ((Link) linkdata.nextElement()).showLink();
	 	}
	 	return result;
	}


}
