package logger;

/** Java class "StreamHandler.java" generated from Poseidon for UML.
 *  Poseidon for UML is developed by <A HREF="http://www.gentleware.com">Gentleware</A>.
 *  Generated with <A HREF="http://jakarta.apache.org/velocity/">velocity</A> template engine.
 */
import java.util.*;
import java.io.*;

/**
 * <p>
 *
 * @author H. Adam
 * </p>
 */
public class StreamHandler
{

  ///////////////////////////////////////
  // attributes


/**
 * <p>
 * Represents the configuration of this StreamHandler
 *
 * <li>0 ... logging
 * <li>1 ... timestamp
 * <li>2 ... prefix
 * </p>
 */
    private BitSet config_;

/**
 * <p>
 * Represents the prefix of a message
 * </p>
 */
    private String prefix_;

/**
 * <p>
 * Represents the OutputStream to write
 * </p>
 */
    private OutputStream outputstream_;

  ///////////////////////////////////////
  // operations


/**
 * <p>
 *  * StreamHandler has all information for one LoggingUnit
 * </p><p>
 *
 * </p><p>
 * @param outputstream the OutputStream to write to
 * </p>
 */
    public  StreamHandler(OutputStream outputstream)
    { /** lock-end */
        outputstream_ = outputstream;
        config_ = new BitSet(3);
        config_.set(0);
        prefix_ = "";
    } // end StreamHandler        /** lock-begin */

/**
 * <p>
 * Returns the OutputStream to write to
 * </p><p>
 *
 * @return a OutputStream
 * </p>
 */
    public OutputStream getOutPutStream()
    { /** lock-end */
        return outputstream_;
    } // end getOutPutStream        /** lock-begin */

/**
 * <p>
 * Set the prefix to a new value
 * </p><p>
 *
 * @new_prefix new prefix
 * </p>
 */
    public void setPrefix(String new_prefix)
    { /** lock-end */
        prefix_ = new_prefix;
    } // end getConfig        /** lock-begin */

/**
 * <p>
 * Returns the prefix of this StreamHandler
 * </p><p>
 *
 * </p>
 */
    public String getPrefix()
    { /** lock-end */
        return prefix_;
    } // end getConfig        /** lock-begin */

/**
 * <p>
 * Returns a BitSet with the actual configuration
 * </p><p>
 *
 * @return a BitSet
 * </p>
 */
    public BitSet getConfig()
    { /** lock-end */
        return config_;
    } // end getConfig        /** lock-begin */

/**
 * <p>
 * Replace the actual configuration BitSet
 * </p><p>
 *
 * </p><p>
 *
 * @param new_config the new configuration BitSet
 * </p>
 */
    public void setConfig(BitSet new_config)
    { /** lock-end */
        config_ = new_config;
    } // end setConfig        /** lock-begin */


    public static void main(String[] args)
    {
        boolean test_result = true;
        ByteArrayOutputStream test_stream = new ByteArrayOutputStream();
        StreamHandler test_handler = new StreamHandler(test_stream);
        BitSet compare_bitset = new BitSet();
        compare_bitset.set(0);
        if(!compare_bitset.equals(test_handler.getConfig())) test_result = false;
        compare_bitset.set(1);
        if(compare_bitset.equals(test_handler.getConfig())) test_result = false;
        test_handler.setConfig(compare_bitset);
        if(!compare_bitset.equals(test_handler.getConfig())) test_result = false;
        if(test_stream != test_handler.getOutPutStream()) test_result = false;
        System.out.println("Test StreamHandler: "+test_result);
    }
} // end StreamHandler






