package logger;

/** Java class "StreamHandlerPool.java" generated from Poseidon for UML.
 *  Poseidon for UML is developed by <A HREF="http://www.gentleware.com">Gentleware</A>.
 *  Generated with <A HREF="http://jakarta.apache.org/velocity/">velocity</A> template engine.
 */
import java.util.*;

/**
 * <p>
 *
 * @author H. Adam
 * </p>
 */
public class StreamHandlerPool
{

/**
 * <p>
 *
 * </p>
 */
    private HashMap streamhandler_store_;

  ///////////////////////////////////////
  // operations


/**
 * <p>
 * StreamHandlerPool stores all StreamHandler known in the logger
 * </p><p>
 *
 * </p>
 */
    public  StreamHandlerPool()
    { /** lock-end */
        streamhandler_store_ = new HashMap();
    } // end StreamHandlerPool        /** lock-begin */

/**
 * <p>
 * Stores a new StreamHandler in the pool
 * </p><p>
 *
 * @param index key to the new StreamHandler
 * </p><p>
 * @param streamhandler new StreamHandler to store
 * @throws StoreException if index is allready a key to a StreamHandler
 * </p><p>
 *
 * </p>
 */
    public void addStreamHandler(int index, StreamHandler streamhandler) throws StoreException
    { /** lock-end */
        Integer new_key = new Integer(index);
        if(streamhandler_store_.containsKey(new_key)) throw new StoreException("this key allready exists");
        else
        {
            streamhandler_store_.put(new_key,streamhandler);
        }
    } // end addStreamHandler        /** lock-begin */

/**
 * <p>
 * Gets the StreamHandler associated with the index and returns it
 * </p><p>
 * @param index associated with the StreamHandler
 * </p><p>
 *
 * @return a StreamHandler associated with index
 * @throws StoreException if index is not known
 * </p>
 */
    public StreamHandler getStreamHandler(int index) throws StoreException
    { /** lock-end */
        Integer key = new Integer(index);
        Object result = streamhandler_store_.get(key);
        if(result == null) throw new StoreException("key is unknown");
        return (StreamHandler) result;
    } // end getStreamHandler        /** lock-begin */

    public static void main(String[] agrs)
    {
        boolean test_result = true;
        StreamHandlerPool test_pool = new StreamHandlerPool();
        StreamHandler test_handler =  new StreamHandler(null);
        try
        {
            test_pool.getStreamHandler(20);
            test_result = false;
        }
        catch(StoreException e)
        {
   //         System.out.println(e.toString());
        }
        try
        {
            test_pool.addStreamHandler(30,test_handler);
        }
        catch(StoreException e)
        {
            test_result = false;
        }
        try
        {
            test_pool.addStreamHandler(30,test_handler);
            test_result = false;
        }
        catch(StoreException e)
        {
   //         System.out.println(e.toString());
        }
        try
        {
            test_pool.getStreamHandler(29);
            test_result = false;
        }
        catch(StoreException e)
        {
  //          System.out.println(e.toString());
        }
        try
        {
            if(test_handler != test_pool.getStreamHandler(30)) test_result = false;
        }
        catch(StoreException e)
        {
            test_result = false;
        }
        System.out.println("Test StreamHandlerPool: "+test_result);
    }
} // end StreamHandlerPool



