package logger;

/** Java class "Writer.java" generated from Poseidon for UML.
 *  Poseidon for UML is developed by <A HREF="http://www.gentleware.com">Gentleware</A>.
 *  Generated with <A HREF="http://jakarta.apache.org/velocity/">velocity</A> template engine.
 */
import java.util.*;
import java.io.*;
/**
 * <p>
 *
 * @author M. Prangl
 * </p>
 */
public class Writer extends StreamHandlerPoolAccesser {

  ///////////////////////////////////////
  // attributes


/**
 * <p>
 * Represents a flag which tells the status of the logger: false -> initial pahse true -> logging phase
 * </p>
 */
    private boolean logging_phase_;


  ///////////////////////////////////////
  // operations



/**
 * <p>
 * Constructor of Writer
 * </p><p>
 *
 * </p><p>
 *
 * @param pool
 * </p><p>
 * </p>
 */

public Writer(StreamHandlerPool pool)
  {
      super(pool);
	  logging_phase_ = false;

  }



/**
 * <p>
 * adds prefix and timestamp (if enables) and xml-tags to to the message and writes it out to all, for log-enabled streams.
 *
 * </p><p>
 *
 * @param which_loggers, a bitset of all, for login chosen streams
 * </p><p>
 * @param message, the message that schould be written out the stream
 * </p>
 */
    public void writeMessage(BitSet which_loggers, String message) throws PhaseException
	{

		StreamHandler act_stream_handler;
		String act_stream_output ="";
		int count = 0;
		if(logging_phase_)
        {
            try
            {
                for (Enumeration stream_handlers=getStreamHandler(which_loggers); stream_handlers.hasMoreElements();)
				{

					//System.out.println("count: "+count);
					count++;
					act_stream_output = "<log>";
					act_stream_handler=(StreamHandler)stream_handlers.nextElement();

					/* check for enabled prefix */
					if ((act_stream_handler.getConfig()).get(2)) //check for enabled prefix
					{
						act_stream_output = act_stream_output + "<prefix>";
						act_stream_output = act_stream_output + act_stream_handler.getPrefix();
						act_stream_output = act_stream_output + "</prefix>";
					}

					/* check for enabled timestamp */
					if ((act_stream_handler.getConfig()).get(1)) //check for enabled prefix
					{
						act_stream_output = act_stream_output + "<timestamp>";
						act_stream_output = act_stream_output + (new Date().toString());
						act_stream_output = act_stream_output + "</timestamp>";
					}


					act_stream_output = act_stream_output + "<message>";
					act_stream_output = act_stream_output + message;
					act_stream_output = act_stream_output + "</message>";
					act_stream_output = act_stream_output + "</log>\n";

					try
					{
						(act_stream_handler.getOutPutStream()).write(act_stream_output.getBytes());
						(act_stream_handler.getOutPutStream()).flush();
					}
					catch(Exception e)
					{
						System.out.println(e.toString());
					}
				}
            }
            catch(StoreException e)
            {
                System.out.println(e.toString());
            }
        }
        else
        {
            throw new PhaseException("logging phase is not reached, submit enterLogginState() before a log command! ");
        }



    } // end writeMessage        /** lock-begin */

/**
 * <p>
 * Signals the Writer that the initial-phase is over.
 * </p><p>
 *
 * </p>
 */
    public void enterLoggingState()
	{        /** lock-end */

		logging_phase_ = true;

    } // end enterLoggingState        /** lock-begin */




	/*Dummy testfunction */
	 public static void main(String[] args)
    {
      boolean test_result = true;
      try
      {
	  	FileOutputStream test_writer1 = new FileOutputStream("test1.tst");
	  	FileOutputStream test_writer2 = new FileOutputStream("test2.tst");
	  	FileOutputStream test_writer3 = new FileOutputStream("test3.tst");
	  	FileOutputStream test_writer4 = new FileOutputStream("test4.tst");
	  	StreamHandler shtest1 = new StreamHandler(test_writer1);
		StreamHandler shtest2 = new StreamHandler(test_writer2);
	  	StreamHandler shtest3 = new StreamHandler(test_writer3);
	 	StreamHandler shtest4 = new StreamHandler(test_writer4);
	  	shtest1.setPrefix("PEFIX _TEST1");
	  	shtest2.setPrefix("PEFIX _TEST2");
                shtest3.setPrefix("PEFIX _TEST3");

		BitSet config2 = new BitSet();
		config2.set(0);
		config2.set(1);
		shtest2.setConfig(config2);
		BitSet config3 = new BitSet();
		config3.set(0);
		config3.set(1);
		config3.set(2);
		shtest3.setConfig(config3);

	  	StreamHandlerPool dummypool = new StreamHandlerPool();
	  	dummypool.addStreamHandler(1,shtest1);
	  	dummypool.addStreamHandler(2,shtest2);
	  	dummypool.addStreamHandler(3,shtest3);
	  	dummypool.addStreamHandler(4,shtest4);
	  	System.out.println("Test Writer: "+test_result);

		Writer testwriter= new Writer(dummypool);
		BitSet select = new BitSet();
		select.set(1);
		select.set(2);
		select.set(3);
		select.set(4);


		testwriter.enterLoggingState();
		testwriter.writeMessage(select,"this is a TESTMESSAGE line 1!");
		testwriter.writeMessage(select,"this is a TESTMESSAGE line 2!");

		test_writer1.close();
		test_writer2.close();
		test_writer3.close();
		test_writer4.close();


	  }
	  catch (Exception e)
      {
      	test_result = false;
		e.printStackTrace();
      }

	  System.out.println("Test StreamHandler: "+test_result);
    }


} // end Writer



